# Obtaining decryption keys for generic services (no headers, no auth)

## Prerequisite 
Download and extracted [TPD-Keys](https://cdm-project.com/Decryption-Tools/TPD-Keys "TPD-Keys")

Working CDM

[EME Logger Script](https://greasyfork.org/en/scripts/373903-eme-logger "EME Logger Script") (installed on [Tampermonkey](https://www.tampermonkey.net/ "Tampermonkey") add-on) will give you init data. That's your PSSH. This can be found on Developer Tools (ctrl + shift + c) > Console, in the filter bar search for `MediaKeySession::generateRequest` you will find Init Data.

## Obtaining Keys

Open a new command prompt as administrator and change directories to TPD-Keys

Open Firefox or Chrome and navigate back to [https://bitmovin.com/demos/drm](https://bitmovin.com/demos/drm "https://bitmovin.com/demos/drm") and open web devoloper tools (ctrl+shift+c) and click on the network tab

In the `Console` tab filter bar, search for `MediaKeySession::generateRequest`

Play the video on the site

You should now have one result for the PSSH 
`AAAAW3Bzc2gAAAAA7e+LqXnWSs6jyCfc1R0h7QAAADsIARIQ62dqu8s0Xpa7z2FmMPGj2hoNd2lkZXZpbmVfdGVzdCIQZmtqM2xqYVNkZmFsa3IzaioCSEQyAA==`
Paste this somewhere safe.

click on the network tab, then in the filter urls type in `method:POST` and under the domain look for the licensing server, in this case it's `https://cwip-shaka-proxy.appspot.com/no_auth` right click on this value and copy value -> copy URL and paste this somewhere safe.

Now we have everything we need, let's go ahead and run tpd-keys with `python tpd-keys.py`, Select option 1 for `Generic without any headers`

For PSSH enter `AAAAW3Bzc2gAAAAA7e+LqXnWSs6jyCfc1R0h7QAAADsIARIQ62dqu8s0Xpa7z2FmMPGj2hoNd2lkZXZpbmVfdGVzdCIQZmtqM2xqYVNkZmFsa3IzaioCSEQyAA==`

for license URL enter
`https://cwip-shaka-proxy.appspot.com/`

Decide if you want to use a proxy or not.

Your result should be

```
Decryption keys:
ccbf5fb4c2965be7aa130ffb3ba9fd73:9cc0c92044cb1d69433f5f5839a159df
9bf0e9cf0d7b55aeb4b289a63bab8610:90f52fd8ca48717b21d0c2fed7a12ae1
eb676abbcb345e96bbcf616630f1a3da:100b6c20940f779a4589152b57d2dacb
0294b9599d755de2bbf0fdca3fa5eab7:3bda2f40344c7def614227b9c0f03e26
639da80cf23b55f3b8cab3f64cfa5df6:229f5f29b643e203004b30c4eaf348f4
```
And there you have it! decryption keys for all versions of the video and one for the audio.

